#ifdef SVL_OFFSCREEN_BUFFER

//todo-- add full lasik header
//author-- Ian Goodfellow <ia3n@cs.stanford.edu>
//description-- class for rendering things in opengl to an image rather than to the screen

#pragma once

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include "svlVision.h"


class svlOffscreenBuffer
{
 public:

  svlOffscreenBuffer(unsigned w, unsigned h);
  ~svlOffscreenBuffer();

  void setActive(bool active);

  IplImage * getImage() const; //caller becomes the owner of the returned image-- you can do anything you like to it / are responsible for freeing it

  static bool statusOK(GLenum status);
  static string statusToStr(GLenum status);

  protected:

  unsigned _w;
  unsigned _h;
  bool _active;

  GLuint _frameBufferObject;
  GLuint _depthBuffer;
  GLuint _texture;
  GLint _viewport[4];
  

};

#endif
